// show hide toggle visible.
Element.prototype.visible = function() {
	return this.style.display != 'none';
};
Element.prototype.hide = function() {
	this.style.display = 'none';
};
Element.prototype.show = function() {
	this.style.display = '';
};
Element.prototype.toggle = function() {
	if (this.visible()) {
		this.hide();
	} else {
		this.show();
	}
};

//
var proxy_server_url = "http://dict.youdao.com/dp/";

var image_path="images/"



function changeToTestServer() {
	proxy_server_url = "http://tb039x.corp.youdao.com:9119/";
}

// ajax
HTTP={}
HTTP.newRequest = function () {
	if (window.ActiveXObject) {
		return new ActiveXObject('Microsoft.XMLHTTP');
	} else if (window.XMLHttpRequest) {
		return new XMLHttpRequest();
	} else {
		 return false;
	}
};
HTTP.getText = function(url, callback) {
	var request = HTTP.newRequest();
	request.onreadystatechange = function() {
		if (request.readyState == 4 && request.status == 200) {
			callback(request.responseText);
		}
	};
	request.open("GET", url);
	request.send(null);
};
// ajax end
function $(x) {
	return document.getElementById(x);
}
function displayImg(block){
	// we got two kinds of css in v1.0 and v1.1, this code will make both of them work.
	var blockImg = $(block + "_right");
	if (blockImg) {
		if (blockImg.tagName == "DIV") {	// it's div in v1.1
			blockImg.className = "title_right_display";
		} else {	// it's img in v1.0
			blockImg.src = image_path + "title_right_display.gif";
		}
	}
}
function foldImg(block){
	var blockImg = $(block + "_right");
	if (blockImg) {
		if (blockImg.tagName == "DIV") {
			blockImg.className = "title_right_fold";
		} else {
			blockImg.src = image_path + "title_right_fold.gif";
		}
	}
}
var getElemXY = function (elem) {
	var sumTop = 0;
	var sumLeft = 0;
	while (elem) {
		sumLeft += elem.offsetLeft  || 0;
		sumTop += elem.offsetTop  || 0;
		elem = elem.offsetParent;
	}
	return {x:sumLeft, y:sumTop};
};
function loadingNext() {
	$("main").hide();
	$("loading_tip").show();
}
function cancelLoading() {
	$("loading_tip").hide();
	$("main").show();
}
function trimBlank(i) {
	var str = i.innerHTML;
	i.innerHTML = str.replace(/\s/gi,"");
}
function changeBlock(hideId, showId) {
	$(hideId).hide();
	$(showId).show();
}
function showDefinition(block) {
	// 如果block这个id存在，并且有内容，我们只是将其变成hidden，如果不存在，则需要下载。
	var eleBlock = $(block);
	if (eleBlock) {
		var blockBody = $(block+"_body");
		displayImg(block);
		if (blockBody) {
			blockBody.show();
		} else {
			var additionalParam = eleBlock.getAttribute("addP") || "";
			var prefixQuery = eleBlock.getAttribute("preQ") || "";
			var suffixQuery = eleBlock.getAttribute("sufQ") || "";
			$(block).innerHTML = ("<p align=center><img align='absmiddle' src='" + image_path + "loading.gif'/><b>加载中...</b></p>");
			HTTP.getText(proxy_server_url + "dp?block=" + block + additionalParam + "&q=" + prefixQuery + encodeURIComponent(global_q) + suffixQuery + global_params, function(transport) {
				$(block).innerHTML = bridge.handle(transport,0);
			}
			);
		}
	}
}
function loadMoreLj() {
	var moreSentenseDiv = $("more_sentence");
	$("more_lj").innerHTML = ("<img align='absmiddle' src='" + image_path + "loading.gif'><b>更多例句加载中...</b>");
	HTTP.getText(proxy_server_url + "dp?block=morelj&q=lj:" + encodeURIComponent(global_q) + global_params, function(transport) {
		moreSentenseDiv.innerHTML = bridge.handle(transport,1);
		$("more_lj").hide();
	}
	);
}
function loadMoreBlock(divName, tipTagName, blockName, additionalParam, prefixQuery, suffixQuery, loadingString) {
	additionalParam = additionalParam || "";
	prefixQuery = prefixQuery || "";
	suffixQuery = suffixQuery || "";
	loadingString = loadingString || "加载中...";
	var moreContentDiv = $(divName);
	$(tipTagName).innerHTML = ("<img align='absmiddle' src='" + image_path + "loading.gif'><b>"+loadingString+"</b>");
	HTTP.getText(proxy_server_url + "dp?block=" + blockName + additionalParam + "&q=" + prefixQuery + encodeURIComponent(global_q) + suffixQuery + global_params, function(transport) {
		moreContentDiv.innerHTML = bridge.handle(transport,2);
		$(tipTagName).hide();
	}
	);
}
function fold(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
		window.scrollTo(0, getElemXY(blockBody).y-43);
	}
	hideDefinition(block);
}
function hideDefinition(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
		foldImg(block);
		blockBody.hide();
	}
}
function toggleShowHide(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
		blockBody.toggle();
		if (blockBody.visible()) {
			displayImg(block);
		} else {
			foldImg(block);
		}
	} else {
		showDefinition(block);
	}
}
function showAll() {
	var elems = getBlocks($("main"));
	if (elems.length > 0) {
		for (var i = 0; i < elems.length; i++) {
			showDefinition(elems[i].id);
		}
	} else {
		var blocks = ['ee', 'hh', 'auth', 'phrase', 'synonyms', 'web', 'authsent', 'sentence', 'baike'];
		for (var i = 0; i < blocks.length; i++) {
			showDefinition(blocks[i]);
		}
	}
}
function hideAll() {
	var elems = getBlocks($("main"));
	if (elems.length > 0) {
		for (var i = 0; i < elems.length; i++) {
			hideDefinition(elems[i].id);
		}
	} else {
		var blocks = ['ee', 'hh', 'auth', 'phrase', 'synonyms', 'web', 'authsent', 'sentence', 'baike'];
		for (var i = 0; i < blocks.length; i++) {
			hideDefinition(blocks[i]);
		}
	}
}
function getBlocks(element) {
	var children = element.childNodes;
	var elems = [];
	if (children) {
		for (var i=0; i<children.length; i++) {
			if (children[i].nodeType == document.ELEMENT_NODE) {
				if (children[i].tagName == "DIV" && children[i].getAttribute("foldable")) {
					elems.push(children[i]);
				}
			}
		}
	}
	return elems;
}
function changeBlock(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
		blockBody.show();
		var blockTab = $(block+"_tab");
		if (blockTab) {
			blockTab.className = "active";
			var children = blockTab.parentNode.childNodes;
			if (children) {
				for (var i = 0; i < children.length; i++) {
					if (children[i].nodeType == document.ELEMENT_NODE) {
						if (children[i].tagName == "A") {
							var image = children[i].firstElementChild;
							if (image) {
								image.src = image_path + "frame_right_display.gif";
							}
						}
					}
				}
			}
		}
		var container = blockBody.parentNode;
		if (container) {
			var children = container.childNodes;
			if (children) {
				for (var i = 0; i < children.length; i++) {
					if (children[i].nodeType == document.ELEMENT_NODE) {
						var indexBlockName = children[i].id.indexOf("_body");
						if (children[i].tagName == "DIV" && indexBlockName > 0) {
							var childName = children[i].id.substring(0, indexBlockName);
							if (childName != block) {
								children[i].hide();
								var childTab = $(childName+"_tab");
								if (childTab) {
									childTab.className = "";
								}
							}
						}
					}
				}
			}
		}
	}
}
function toggleFrame(frame) {
	var frameIcon = $(frame + "_icon");
	if (!frameIcon) {
		return;
	}
	var toShow = false;
	if (frameIcon.src.indexOf("fold") >= 0) {
		frameIcon.src = image_path + "frame_right_display.gif";
		toShow = true;
	}
	else {
		frameIcon.src = image_path + "frame_right_fold.gif";
		toShow = false;
	}
	var frameHeader = $(frame + "_head");
	if (!frameHeader) {
		return;
	}
	var children = frameHeader.childNodes;
	if (!children) {
		return;
	}
	for (var i = 0; i < children.length; i++) {
		if (children[i].nodeType == document.ELEMENT_NODE) {
			var indexBlockName = children[i].id.indexOf("_tab");
			if (children[i].tagName == "LI" && indexBlockName > 0) {
				if (children[i].className == "active") {
					var childName = children[i].id.substring(0, indexBlockName);
					var blockBody = $(childName + "_body");
					if (blockBody && toShow) {
						blockBody.show();
					} else if (blockBody && !toShow) {
						blockBody.hide();
					}
					break;
				}
			}
		}
	}
}

function adjustPosition(){var m=document.getElementById("main");var ad=document.getElementById("ead_dict_1");ad.style.width=getW();if(getH()-(m.offsetHeight + m.offsetTop)>54){ad.style.top=getH()-54;}else{ad.style.top=m.offsetTop+m.offsetHeight+20;}}
function getW(){var w=0;if(typeof(window.innerWidth)=='number'){w = window.innerWidth;}else{if (document.documentElement&&document.documentElement.clientWidth){w=document.documentElement.clientWidth;}else{if(document.body&&document.body.clientWidth){w=document.body.clientWidth;}}}return w - 16;}
function getH(){var w=0;if(typeof(window.innerHeight)=='number'){w = window.innerHeight;}else{if(document.documentElement&&document.documentElement.clientHeight){w=document.documentElement.clientHeight;}else{if(document.body&&document.body.clientHeight){w=document.body.clientHeight;}}}return w;}
function loadAd(){var scriptBlock=document.createElement("script");scriptBlock.type="text/javascript";scriptBlock.language = "javascript";scriptBlock.src = "http://tb104x.corp.youdao.com:2211/ads?type=text&ip=192.168.1.6"+"&r=" + getRamdon();document.getElementsByTagName("head")[0].appendChild(scriptBlock);}
function getRamdon() {
	var myDate = new Date();
	var ret = 0;
    ret += myDate.getYear();        //获取当前年份(2位)
    ret += myDate.getFullYear();    //获取完整的年份(4位,1970-????)
    ret += myDate.getMonth();       //获取当前月份(0-11,0代表1月)
    ret += myDate.getDate();        //获取当前日(1-31)
    ret += myDate.getHours();       //获取当前小时数(0-23)
    return ret;
};
window.onresize = function(event){adjustPosition();}
