//constant

var DICT_TYPE_PHRASE = '4';


// show hide toggle visible.
Element.prototype.visible = function() {
	return this.style.display != 'none';
};
Element.prototype.hide = function() {
	this.style.display = 'none';
};
Element.prototype.show = function() {
	this.style.display = '';
};
Element.prototype.toggle = function() {
	if (this.visible()) {
		this.hide();
	} else {
		this.show();
	}
};

var proxy_server_url="http://dict.youdao.com/dp/"
var image_path="images/"
// ajax
HTTP={}
HTTP.newRequest = function () {
	if (window.ActiveXObject) {
		return new ActiveXObject('Microsoft.XMLHTTP');
	} else if (window.XMLHttpRequest) {
		return new XMLHttpRequest();
	} else {
		 return false;
	}
};
HTTP.getText = function(url, callback) {
	var request = HTTP.newRequest();
	request.onreadystatechange = function() {
		if (request.readyState == 4 && request.status == 200) {
			callback(request.responseText);
		}
	};
	
	request.open("GET", url);
	request.send(null);
};
// ajax end
function $(x) {
	return document.getElementById(x);
}
function displayImg(block){
	// we got two kinds of css in v1.0 and v1.1, this code will make both of them work.
	var blockImg = $(block + "_right");
	if (blockImg) {
		if (blockImg.tagName == "DIV") {	// it's div in v1.1
			blockImg.className = "title_right_display";
		} else {	// it's img in v1.0
			blockImg.src = image_path + "title_right_display.gif";
		}
	}
}
function foldImg(block){
	var blockImg = $(block + "_right");
	if (blockImg) {
		if (blockImg.tagName == "DIV") {
			blockImg.className = "title_right_fold";
		} else {
			blockImg.src = image_path + "title_right_fold.gif";
		}
	}
}
var getElemXY = function (elem) {
	var sumTop = 0;
	var sumLeft = 0;
	while (elem) {
		sumLeft += elem.offsetLeft  || 0;
		sumTop += elem.offsetTop  || 0;
		elem = elem.offsetParent;
	}
	return {x:sumLeft, y:sumTop};
};
function loadingNext() {
	$("main").hide();
	$("loading_tip").show();
}
function cancelLoading() {
	$("loading_tip").hide();
	$("main").show();
}
function trimBlank(i) {
	var str = i.innerHTML;
	i.innerHTML = str.replace(/\s/gi,"");
}
function changeBlock(hideId, showId) {
	$(hideId).hide();
	$(showId).show();
}

//used in android
function writeLog(text) {
   if (bridge)
       bridge.Log(text);
}

function showDefinition(block) {
	// 如果block这个id存在，并且有内容，我们只是将其变成hidden，如果不存在，则需要下载。
	var eleBlock = $(block);
	if (eleBlock) {
		var blockBody = $(block+"_body");
		displayImg(block);
		if (blockBody) {
			blockBody.show();
		} else {
			var additionalParam = eleBlock.getAttribute("addP") || "";
			var prefixQuery = eleBlock.getAttribute("preQ") || "";
			var suffixQuery = eleBlock.getAttribute("sufQ") || "";
			$(block).innerHTML = ("<p align=center><img align='absmiddle' src='" + image_path + "loading.gif'/><b>加载中...</b></p>");
			HTTP.getText(proxy_server_url + "dp?block=" + block + additionalParam + "&q=" + prefixQuery + encodeURIComponent(global_q) + suffixQuery + global_params, function(transport) {
				$(block).innerHTML = transport;
			}
			);
		}
	}
}
function loadMoreLj() {
	var moreSentenseDiv = $("more_sentence");
	$("more_lj").innerHTML = ("<img align='absmiddle' src='" + image_path + "loading.gif'><b>更多例句加载中...</b>");
	HTTP.getText(proxy_server_url + "dp?block=morelj&q=lj:" + encodeURIComponent(global_q) + global_params, function(transport) {
		moreSentenseDiv.innerHTML = transport;
		$("more_lj").hide();
	}
	);
}
function loadMoreBlock(divName, tipTagName, blockName, additionalParam, prefixQuery, suffixQuery, loadingString) {
	additionalParam = additionalParam || "";
	prefixQuery = prefixQuery || "";
	suffixQuery = suffixQuery || "";
	loadingString = loadingString || "加载中...";
	$(tipTagName).innerHTML = ("<img align='absmiddle' src='" + image_path + "loading.gif'><b>"+loadingString+"</b>");
	bridge.queryInOfflineDict(global_q, divName, "offlineDictcallBack");
    /*
	HTTP.getText(proxy_server_url + "dp?block=" + blockName + additionalParam + "&q=" + prefixQuery + encodeURIComponent(global_q) + suffixQuery + global_params, function(transport) {
		moreContentDiv.innerHTML = transport;
                writeLog("loadMoreBlock called!");
		$(tipTagName).hide();
	}
	);*/
}
function fold(block) {
    writeLog("fold block" + block + "_body called!");
	var blockBody = $(block+"_body");
	if (blockBody) {
		window.scrollTo(0, getElemXY(blockBody).y - 43);
	}
	hideDefinition(block);
}
function hideDefinition(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
		foldImg(block);
		blockBody.hide();
	}
}
function toggleShowHide(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
	    writeLog(blockBody.id + "exist");
		blockBody.toggle();
		if (blockBody.visible()) {
			displayImg(block);
		} else {
			foldImg(block);
		}
	} else {
		showDefinition(block);
	}
}
function showAll() {
	var elems = getBlocks($("main"));
	if (elems.length > 0) {
		for (var i = 0; i < elems.length; i++) {
			showDefinition(elems[i].id);
		}
	} else {
		var blocks = ['ee', 'hh', 'auth', 'phrase', 'synonyms', 'web', 'authsent', 'sentence', 'baike'];
		for (var i = 0; i < blocks.length; i++) {
			showDefinition(blocks[i]);
		}
	}
}
function hideAll() {
	var elems = getBlocks($("main"));
	if (elems.length > 0) {
		for (var i = 0; i < elems.length; i++) {
			hideDefinition(elems[i].id);
		}
	} else {
		var blocks = ['ee', 'hh', 'auth', 'phrase', 'synonyms', 'web', 'authsent', 'sentence', 'baike'];
		for (var i = 0; i < blocks.length; i++) {
			hideDefinition(blocks[i]);
		}
	}
}
function getBlocks(element) {
	var children = element.childNodes;
	var elems = [];
	if (children) {
		for (var i=0; i<children.length; i++) {
			if (children[i].nodeType == document.ELEMENT_NODE) {
				if (children[i].tagName == "DIV" && children[i].getAttribute("foldable")) {
					elems.push(children[i]);
				}
			}
		}
	}
	return elems;
}
function changeBlock(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
		blockBody.show();
		var blockTab = $(block+"_tab");
		if (blockTab) {
			blockTab.className = "active";
			var children = blockTab.parentNode.childNodes;
			if (children) {
				for (var i = 0; i < children.length; i++) {
					if (children[i].nodeType == document.ELEMENT_NODE) {
						if (children[i].tagName == "A") {
							var image = children[i].firstElementChild;
							if (image) {
								image.src = image_path + "frame_right_display.gif";
							}
						}
					}
				}
			}
		}
		var container = blockBody.parentNode;
		if (container) {
			var children = container.childNodes;
			if (children) {
				for (var i = 0; i < children.length; i++) {
					if (children[i].nodeType == document.ELEMENT_NODE) {
						var indexBlockName = children[i].id.indexOf("_body");
						if (children[i].tagName == "DIV" && indexBlockName > 0) {
							var childName = children[i].id.substring(0, indexBlockName);
							if (childName != block) {
								children[i].hide();
								var childTab = $(childName+"_tab");
								if (childTab) {
									childTab.className = "";
								}
							}
						}
					}
				}
			}
		}
	}
}
function toggleFrame(frame) {
	var frameIcon = $(frame + "_icon");
	if (!frameIcon) {
		return;
	}
	var toShow = false;
	if (frameIcon.src.indexOf("fold") >= 0) {
		frameIcon.src = image_path + "frame_right_display.gif";
		toShow = true;
	}
	else {
		frameIcon.src = image_path + "frame_right_fold.gif";
		toShow = false;
	}
	var frameHeader = $(frame + "_head");
	if (!frameHeader) {
		return;
	}
	var children = frameHeader.childNodes;
	if (!children) {
		return;
	}
	for (var i = 0; i < children.length; i++) {
		if (children[i].nodeType == document.ELEMENT_NODE) {
			var indexBlockName = children[i].id.indexOf("_tab");
			if (children[i].tagName == "LI" && indexBlockName > 0) {
				if (children[i].className == "active") {
					var childName = children[i].id.substring(0, indexBlockName);
					var blockBody = $(childName + "_body");
					if (blockBody && toShow) {
						blockBody.show();
					} else if (blockBody && !toShow) {
						blockBody.hide();
					}
					break;
				}
			}
		}
	}
}

//used in android
function queryInOfflineDict(block) {	
	var eleBlock = $(block);
	if (eleBlock) {
		var blockBody = $(block+"_body");
		displayImg(block);
		if (blockBody) {
			blockBody.show();
		} else {			
			$(block).innerHTML = ("<p align=center><img align='absmiddle' src='" + image_path + "loading.gif'/><b>加载中...</b></p>");
			bridge.queryInOfflineDict(global_q, block, "offlineDictcallBack");
			
		}
	}
}

function localShowHide(block) {
	var blockBody = $(block+"_body");
	if (blockBody) {
	    
		blockBody.toggle();
		if (blockBody.visible()) {
			displayImg(block);
		} else {
			foldImg(block);
		}
	} else {
		queryInOfflineDict(block);
	}
}

//this function will be called, in the android client
function offlineDictcallBack(html, block) {
	var mblock = $(block);
	if (mblock) {
		$(block).innerHTML = html;
	}
	
	writeLog("hide tips called!");
	var tipBlock = $("more_phrs");
	if (tipBlock && block.indexOf(DICT_TYPE_PHRASE) != -1) {
	    tipBlock.hide();
	}
}

//global variables used for back link query
var clientX, clientY;
var pageX, pageY;
var isPhoneMode = false;
var mousePos = {};
//p, div,h1, h2, h3, h4, h5, h6, li, span,  blockquote, i, b, u, strong, small, em, cite, strike, sub, sup,var,q,pre
var knownTextTags = ['p', 'div','h1', 'h2', 'h3', 'h4', 'h5', 'h6', 'li', 'span',  'blockquote', 'i', 'b', 'u', 'strong', 'small', 'em', 'cite', 'strike', 'sub', 'sup','var','q','pre'];

var ENUM_FUNCTION = 1;
var ENUM_PROPERTY = 2;
var ENUM_ALL = ENUM_FUNCTION | ENUM_PROPERTY;



var isAlpha = function(str) {
	return/[a-zA-Z']+/.test(str)
};

function isKnowTextTag(tag) {
	tag = tag.toLowerCase();
	for (var i = 0; i < knownTextTags.length; i++) {
		if (tag == knownTextTags[i]) {
			return true;
		} 
    	}
	return false;
}

function isChinese(unicodeChar) {
	var re = /[^\u4e00-\u9fa5]/;
	if(re.test(unicodeChar)) {
		return false
	}
	return true
};

function isToken(str) {
	if (str == "n" || str == "vt" || str == "vi") {
		return true;
	}
	return false;
};


function enumObject(obj, enumType) {
	if (!obj) {
		return;
	}
	if (!enumType) {
		enumType = ENUM_ALL;
	}
	var str;
	for (o in obj) {
		var type = typeof (obj[o]);
		if ((type == 'function' && (enumType & ENUM_FUNCTION)) || (type != 'function' && (enumType & ENUM_PROPERTY))) {
		str += type + ":" + o + "\n";
		}
	}
	writeLog(str);
}


function backQueryWord(word) {
	var url = "back:" + word;
	writeLog("backQueryWord called, the query url is: " + url);
	window.open(url);
};



function get_word_by_mouse(x,y) {
	var r = document.caretRangeFromPoint(x, y);   
	if (r == null) {
		return  "";
	}
	do {
		if(!r) {
			break
		}
		var so = r.startOffset, eo = r.endOffset;
		var cnt = 0;
		var space_cnt = 0;
		var tr = r.cloneRange(), text = ""; 
		var node = r.startContainer;
		var tagName = "";
		if (node.nodeType == 3 /*text node*/) {
			node = node.parentNode;       
		}
		tagName = node.tagName;
		if (!isKnowTextTag(tagName)) {
			return "";
		}
		if (r.startContainer.data) {  
			while (so >= 1) {
				tr.setStart(r.startContainer, --so);
				text = tr.toString();
				if (!isAlpha(text.charAt(0))) {
					if (isChinese(text.charAt(0))) {
						return ""; //遇到中文直接返回空
					}
					if (text.charAt(0) == " ") {
						space_cnt++;
					}
					//遇到第一个非字符的设为起点
					if(space_cnt == 1 || space_cnt == 0) {
						tr.setStart(r.startContainer, so + 1);
						break;
					}
				}
				cnt++;
			}
		}
		if (cnt == 0) {
			break;
		}
		cnt = 0;
		space_cnt = 0;
		if (r.endContainer.data) {
			while (eo < r.endContainer.data.length) {   
				tr.setEnd(r.endContainer, ++eo);
				text = tr.toString();
				if (!isAlpha(text.charAt(text.length - 1))) {
					if (isChinese(text.charAt(text.length - 1))) {
 						return ""; //遇到中文直接返回空
					}
					if (text.charAt(text.length - 1) == " ") {
						space_cnt++;
					}
					//遇到第一个非字符的设为终点
					if (space_cnt == 0 || space_cnt == 1) {
						tr.setEnd(r.endContainer, eo - 1);
						break;
					}
				}
				cnt++;
			}
   		 }
		if (cnt == 0) {
			break;
		}
		var word = tr.toString();
    	
		if (word.length >= 1 || !isToken(word)) {
			backQueryWord(word);
			return word;
		}
	} while(0);
	return ""
};


function handleClick(e){
	var offsetX = window.scrollX? window.scrollX : 0;
	var offsetY = window.scrollY? window.scrollY : 0;
	var eventDefX = (e.touches && e.touches.length > 0? e.touches[0].pageX : (e.changedTouches && e.changedTouches.length > 0? e.changedTouches[0].pageX : e.pageX));
	var eventDefY = (e.touches && e.touches.length > 0? e.touches[0].pageY : (e.changedTouches && e.changedTouches.length > 0? e.changedTouches[0].pageY : e.pageY));
	var eventClientX = eventDefX - offsetX;
	var eventClientY = eventDefY - offsetY;
	if (isPhoneMode) {
		isPhoneMode = false;
		if (mousePos.x && mousePos.y) {
			var xx = mousePos.x;
			var yy = mousePos.y;
			var pageX = (e.touches && e.touches.length > 0? e.touches[0].pageX : (e.changedTouches && e.changedTouches.length > 0? e.changedTouches[0].pageX : e.pageX));
			var pageY = (e.touches && e.touches.length > 0? e.touches[0].pageY : (e.changedTouches && e.changedTouches.length > 0? e.changedTouches[0].pageY : e.pageY));
			var clientX = pageX - offsetX;
			var clientY = pageY - offsetY;

 			var diff = {};
			diff.x = xx - parseInt(clientX);
			diff.y = yy - parseInt(clientY);
			diff.dis = diff.x * diff.x + diff.y * diff.y;
			mousePos = {};
			if (diff.dis > 900) {
				// The moving action with more than 30 pixels is justified as dragging.
				return;
			} else {
				get_word_by_mouse(eventClientX, eventClientY);
			}
		} 
	}
}


function handleTouchStart(e) {
	// Notice: mousePos is the client coordinate of the start of touch.
	// The page/client/screen coordinates on iOS are all the same as the page one, which seems to be a bug.
	// However, we could solve it in this way: change the page(x, y) to client(x, y) by subtracting window.scroll(x, y)
	isPhoneMode = true;
	var offsetX = window.scrollX? window.scrollX : 0;
	var offsetY = window.scrollY? window.scrollY : 0;
	if (e.touches && e.touches.length > 0) {
		mousePos.x = e.touches[0].pageX - offsetX;
		mousePos.y = e.touches[0].pageY - offsetY;
	} else if (e.changedTouches && e.changedTouches.length > 0) {
		mousePos.x = e.changedTouches[0].pageX - offsetX;
		mousePos.y = e.changedTouches[0].pageY - offsetY;
	}
}

function initAll(){
	var body = document.body;
	body.addEventListener("click", handleClick, false);
        body.addEventListener("touchstart", handleTouchStart, false); 
	body.addEventListener("touchend", handleClick, false);
}

document.addEventListener("DOMContentLoaded", initAll, false);


